"use strict";

/* eslint-disable no-unused-vars */

import Vue from "vue";

// name 子系统名称
// url 子系统使用的环境变量（请求地址）
const subList = [
  {
    name: "API_LIST_USER",
    url: "VUE_APP_BASE_API"
  },
  {
    name: "API_LIST_ENGINEERINGWORK",
    url: "VUE_APP_BASE_API"
  },
  {
    name: "API_LIST_EXAM",
    url: "VUE_APP_BASE_API"
  },
  {
    name: "API_LIST_EXAM_QUESTION",
    url: "VUE_APP_BASE_API"
  },
  {
    name: "API_LIST_ARTICLE",
    url: "VUE_APP_BASE_API"
  },
  {
    name: "API_LIST_ANSWER_MANAGEMENT",
    url: "VUE_APP_BASE_API"
  },
  {
    name: "API_LIST_COUNT",
    url: "VUE_APP_BASE_API"
  }
];

// 所有api子系统
let API_LIST = {};
const moduleFiles = require.context("./modules", true, /\.js$/);
moduleFiles.keys().forEach(modulePath => {
  API_LIST = { ...API_LIST, ...moduleFiles(modulePath).default };
});

// 合成API地址集合
let apiList = {};
subList.forEach(it => {
  let subApi = Object.entries(API_LIST[it.name]).reduce((target, [key, value]) => {
    target[key] = process.env[it.url].replace(/\W*$/, "") + "/" + value.replace(/^\W*/, "");
    return target;
  }, {});
  apiList = { ...apiList, ...subApi };
});

// 注册所有API地址
Object.defineProperty(Vue.prototype, "$_API", {
  get() {
    return apiList;
  }
});
export default apiList;
